//
// Generated by JTB 1.3.2
//

package org.ow2.mind.adl.jtb.visitor;
import org.ow2.mind.adl.jtb.syntaxtree.*;
import java.util.*;

/**
 * All GJ visitors must implement this interface.
 */

public interface GJVisitor<R,A> {

   //
   // GJ Auto class visitors
   //

   public R visit(NodeList n, A argu);
   public R visit(NodeListOptional n, A argu);
   public R visit(NodeOptional n, A argu);
   public R visit(NodeSequence n, A argu);
   public R visit(NodeToken n, A argu);

   //
   // User-generated visitor methods below
   //

   /**
    * <PRE>
    * f0 -> ( ImportDefinition() )*
    * f1 -> ArchitectureDefinition()
    * f2 -> &lt;EOF&gt;
    * </PRE>
    */
   public R visit(ADLFile n, A argu);

   /**
    * <PRE>
    * f0 -> ( Annotation() )*
    * f1 -> &lt;IMPORT&gt;
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> &lt;DOT&gt;
    * f4 -> ( &lt;IDENTIFIER&gt; &lt;DOT&gt; )*
    * f5 -> ( &lt;START&gt; | &lt;IDENTIFIER&gt; )
    * f6 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(ImportDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> ( TypeDefinition() | PrimitiveDefinition() | CompositeDefinition() )
    * </PRE>
    */
   public R visit(ArchitectureDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;TYPE&gt;
    * f2 -> FullyQualifiedName()
    * f3 -> [ ExtendedTypeDefinitions() ]
    * f4 -> TypeDefinitionBody()
    * </PRE>
    */
   public R visit(TypeDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> TypeDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; TypeDefinitionReference() )*
    * </PRE>
    */
   public R visit(ExtendedTypeDefinitions n, A argu);

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * </PRE>
    */
   public R visit(TypeDefinitionReference n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( TypeDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( TypeDefinitionElement() )*
    * </PRE>
    */
   public R visit(TypeDefinitionBody n, A argu);

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    * </PRE>
    */
   public R visit(TypeDefinitionElement n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> [ &lt;ABSTRACT&gt; ]
    * f2 -> &lt;PRIMITIVE&gt;
    * f3 -> FullyQualifiedName()
    * f4 -> [ FormalParameterDeclarationList() ]
    * f5 -> [ ExtendedPrimitiveDefinitions() ]
    * f6 -> PrimitiveDefinitionBody()
    * </PRE>
    */
   public R visit(PrimitiveDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ FormalParameterDeclaration() ( &lt;COMMA&gt; FormalParameterDeclaration() )* ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(FormalParameterDeclarationList n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(FormalParameterDeclaration n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> PrimitiveDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; PrimitiveDefinitionReference() )*
    * </PRE>
    */
   public R visit(ExtendedPrimitiveDefinitions n, A argu);

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * f1 -> [ ArgumentList() ]
    * </PRE>
    */
   public R visit(PrimitiveDefinitionReference n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ ArgumentAssignement() ( &lt;COMMA&gt; ArgumentAssignement() )* | Argument() ( &lt;COMMA&gt; Argument() )* ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(ArgumentList n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> Argument()
    * </PRE>
    */
   public R visit(ArgumentAssignement n, A argu);

   /**
    * <PRE>
    * f0 -> AttributeValue()
    * </PRE>
    */
   public R visit(Argument n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( PrimitiveDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( PrimitiveDefinitionElement() )*
    * </PRE>
    */
   public R visit(PrimitiveDefinitionBody n, A argu);

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    *       | AttributeDefinition()
    *       | DataDefinition()
    *       | ImplementationDefinition()
    * </PRE>
    */
   public R visit(PrimitiveDefinitionElement n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;COMPOSITE&gt;
    * f2 -> FullyQualifiedName()
    * f3 -> [ FormalTypeParameterDeclarationList() ]
    * f4 -> [ FormalParameterDeclarationList() ]
    * f5 -> [ ExtendedCompositeDefinitions() ]
    * f6 -> CompositeDefinitionBody()
    * </PRE>
    */
   public R visit(CompositeDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LT&gt;
    * f1 -> FormalTypeParameterDeclaration()
    * f2 -> ( &lt;COMMA&gt; FormalTypeParameterDeclaration() )*
    * f3 -> &lt;GT&gt;
    * </PRE>
    */
   public R visit(FormalTypeParameterDeclarationList n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;CONFORMSTO&gt;
    * f2 -> TypeDefinitionReference()
    * </PRE>
    */
   public R visit(FormalTypeParameterDeclaration n, A argu);

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * f1 -> [ TypeArgumentList() ]
    * f2 -> [ ArgumentList() ]
    * </PRE>
    */
   public R visit(CompositeDefinitionReference n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LT&gt;
    * f1 -> [ TypeArgument() ( &lt;COMMA&gt; TypeArgument() )* | TypeArgumentAssignement() ( &lt;COMMA&gt; TypeArgumentAssignement() )* ]
    * f2 -> &lt;GT&gt;
    * </PRE>
    */
   public R visit(TypeArgumentList n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> TypeArgument()
    * </PRE>
    */
   public R visit(TypeArgumentAssignement n, A argu);

   /**
    * <PRE>
    * f0 -> CompositeDefinitionReference()
    *       | &lt;ANY&gt;
    * </PRE>
    */
   public R visit(TypeArgument n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> CompositeDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; CompositeDefinitionReference() )*
    * </PRE>
    */
   public R visit(ExtendedCompositeDefinitions n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( CompositeDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( CompositeDefinitionElement() )*
    * </PRE>
    */
   public R visit(CompositeDefinitionBody n, A argu);

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    *       | BindingDefinition()
    *       | SubComponentDefinition()
    * </PRE>
    */
   public R visit(CompositeDefinitionElement n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> ( FunctionalInterfaceDefinition() | FlowInterfaceDefinition() )
    * </PRE>
    */
   public R visit(InterfaceDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> ( &lt;PROVIDES&gt; | &lt;REQUIRES&gt; )
    * f1 -> [ &lt;OPTIONAL&gt; ]
    * f2 -> FullyQualifiedName()
    * f3 -> &lt;AS&gt;
    * f4 -> &lt;IDENTIFIER&gt;
    * f5 -> [ &lt;LBRACKET&gt; [ &lt;INTEGER_LITERAL&gt; ] &lt;RBRACKET&gt; ]
    * f6 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(FunctionalInterfaceDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> ( &lt;INPUT&gt; | &lt;OUTPUT&gt; )
    * f1 -> [ &lt;OPTIONAL&gt; ]
    * f2 -> FlowType()
    * f3 -> &lt;AS&gt;
    * f4 -> &lt;IDENTIFIER&gt;
    * f5 -> [ &lt;LBRACKET&gt; [ &lt;INTEGER_LITERAL&gt; ] &lt;RBRACKET&gt; ]
    * f6 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(FlowInterfaceDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> AttributeType()
    *       | IDTType()
    * </PRE>
    */
   public R visit(FlowType n, A argu);

   /**
    * <PRE>
    * f0 -> Path()
    * f1 -> &lt;DASH&gt;
    * f2 -> [ &lt;STRUCT&gt; | &lt;ENUM&gt; | &lt;UNION&gt; ]
    * f3 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(IDTType n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;ATTRIBUTE&gt;
    * f2 -> FlowType()
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> [ &lt;ASSIGN&gt; AttributeValue() ]
    * f5 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(AttributeDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;INT&gt;
    *       | &lt;STRING&gt;
    *       | &lt;INT8_T&gt;
    *       | &lt;UINT8_T&gt;
    *       | &lt;INT16_T&gt;
    *       | &lt;UINT16_T&gt;
    *       | &lt;INT32_T&gt;
    *       | &lt;UINT32_T&gt;
    *       | &lt;INT64_T&gt;
    *       | &lt;UINT64_T&gt;
    *       | &lt;INTPTR_T&gt;
    *       | &lt;UINTPTR_T&gt;
    * </PRE>
    */
   public R visit(AttributeType n, A argu);

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | ReferenceValue()
    *       | NullValue()
    *       | CompoundAttributeValue()
    * </PRE>
    */
   public R visit(AttributeValue n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> [ CompoundAttributeValueField() ( &lt;COMMA&gt; CompoundAttributeValueField() )* ]
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(CompoundAttributeValue n, A argu);

   /**
    * <PRE>
    * f0 -> [ CompoundFieldName() ]
    * f1 -> AttributeValue()
    * </PRE>
    */
   public R visit(CompoundAttributeValueField n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;DOT&gt;
    * f1 -> &lt;IDENTIFIER&gt;
    * f2 -> &lt;ASSIGN&gt;
    * </PRE>
    */
   public R visit(CompoundFieldName n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;DATA&gt;
    * f2 -> ( DataField() | DataFile() )
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(DataDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> Path()
    *       | &lt;INLINED_CODE&gt;
    * </PRE>
    */
   public R visit(DataFile n, A argu);

   /**
    * <PRE>
    * f0 -> FlowType()
    * f1 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(DataField n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;SOURCE&gt;
    * f2 -> ( Path() | &lt;INLINED_CODE&gt; )
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(ImplementationDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;BINDS&gt;
    * f2 -> BindingComponentName()
    * f3 -> &lt;DOT&gt;
    * f4 -> &lt;IDENTIFIER&gt;
    * f5 -> [ &lt;LBRACKET&gt; &lt;INTEGER_LITERAL&gt; &lt;RBRACKET&gt; ]
    * f6 -> &lt;TO&gt;
    * f7 -> BindingComponentName()
    * f8 -> &lt;DOT&gt;
    * f9 -> &lt;IDENTIFIER&gt;
    * f10 -> [ &lt;LBRACKET&gt; &lt;INTEGER_LITERAL&gt; &lt;RBRACKET&gt; ]
    * f11 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(BindingDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    *       | &lt;THIS&gt;
    * </PRE>
    */
   public R visit(BindingComponentName n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;CONTAINS&gt;
    * f2 -> SimpleSubComponentReference()
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public R visit(SubComponentDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> [ CompositeDefinitionReference() ]
    * f1 -> &lt;AS&gt;
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> ( &lt;COMMA&gt; &lt;IDENTIFIER&gt; )*
    * f4 -> [ ( PrimitiveAnonymousDefinition() | CompositeAnonymousDefinition() ) ]
    * </PRE>
    */
   public R visit(SimpleSubComponentReference n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;PRIMITIVE&gt;
    * f2 -> &lt;LBRACE&gt;
    * f3 -> ( PrimitiveDefinitionElement() )*
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(PrimitiveAnonymousDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;COMPOSITE&gt;
    * f2 -> &lt;LBRACE&gt;
    * f3 -> ( CompositeDefinitionElement() )*
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(CompositeAnonymousDefinition n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;LBRACE&gt;
    * f2 -> ( PrimitiveDefinitionElement() )*
    * f3 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(PrimitiveAnonymousExtension n, A argu);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;LBRACE&gt;
    * f2 -> ( CompositeDefinitionElement() )*
    * f3 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(CompositeAnonymousExtension n, A argu);

   /**
    * <PRE>
    * f0 -> ( Annotation() )*
    * </PRE>
    */
   public R visit(Annotations n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;AT&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> [ AnnotationParameters() ]
    * </PRE>
    */
   public R visit(Annotation n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ AnnotationValuePairs() | AnnotationValue() ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(AnnotationParameters n, A argu);

   /**
    * <PRE>
    * f0 -> AnnotationValuePair()
    * f1 -> ( &lt;COMMA&gt; AnnotationValuePair() )*
    * </PRE>
    */
   public R visit(AnnotationValuePairs n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> AnnotationValue()
    * </PRE>
    */
   public R visit(AnnotationValuePair n, A argu);

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | BooleanValue()
    *       | AnnotationAnnotationValue()
    *       | ArrayAnnotationValue()
    *       | NullValue()
    *       | PathValue()
    * </PRE>
    */
   public R visit(AnnotationValue n, A argu);

   /**
    * <PRE>
    * f0 -> Annotation()
    * </PRE>
    */
   public R visit(AnnotationAnnotationValue n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> [ AnnotationValue() ( &lt;COMMA&gt; AnnotationValue() )* ]
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(ArrayAnnotationValue n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;STRING_LITERAL&gt;
    * </PRE>
    */
   public R visit(StringValue n, A argu);

   /**
    * <PRE>
    * f0 -> [ &lt;MINUS&gt; | &lt;PLUS&gt; ]
    * f1 -> &lt;INTEGER_LITERAL&gt;
    * </PRE>
    */
   public R visit(IntegerValue n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;BOOLEAN_LITERAL&gt;
    * </PRE>
    */
   public R visit(BooleanValue n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(ReferenceValue n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;NULL&gt;
    * </PRE>
    */
   public R visit(NullValue n, A argu);

   /**
    * <PRE>
    * f0 -> Path()
    * </PRE>
    */
   public R visit(PathValue n, A argu);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( &lt;DOT&gt; &lt;IDENTIFIER&gt; )*
    * </PRE>
    */
   public R visit(FullyQualifiedName n, A argu);

   /**
    * <PRE>
    * f0 -> [ &lt;SLASH&gt; ]
    * f1 -> [ &lt;DOT&gt; &lt;SLASH&gt; ]
    * f2 -> ( &lt;DOTDOT&gt; &lt;SLASH&gt; )*
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> ( &lt;SLASH&gt; &lt;IDENTIFIER&gt; )*
    * f5 -> [ &lt;DOT&gt; &lt;IDENTIFIER&gt; ]
    * </PRE>
    */
   public R visit(Path n, A argu);

}
