//
// Generated by JTB 1.3.2
//

package org.ow2.mind.adl.jtb.visitor;
import org.ow2.mind.adl.jtb.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJVoidDepthFirst<A> implements GJVoidVisitor<A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public void visit(NodeList n, A argu) {
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
   }

   public void visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
      }
   }

   public void visit(NodeOptional n, A argu) {
      if ( n.present() )
         n.node.accept(this,argu);
   }

   public void visit(NodeSequence n, A argu) {
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
   }

   public void visit(NodeToken n, A argu) {}

   //
   // User-generated visitor methods below
   //

   /**
    * <PRE>
    * f0 -> ( ImportDefinition() )*
    * f1 -> ArchitectureDefinition()
    * f2 -> &lt;EOF&gt;
    * </PRE>
    */
   public void visit(ADLFile n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> ( Annotation() )*
    * f1 -> &lt;IMPORT&gt;
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> &lt;DOT&gt;
    * f4 -> ( &lt;IDENTIFIER&gt; &lt;DOT&gt; )*
    * f5 -> ( &lt;START&gt; | &lt;IDENTIFIER&gt; )
    * f6 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public void visit(ImportDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> ( TypeDefinition() | PrimitiveDefinition() | CompositeDefinition() )
    * </PRE>
    */
   public void visit(ArchitectureDefinition n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;TYPE&gt;
    * f2 -> FullyQualifiedName()
    * f3 -> [ ExtendedTypeDefinitions() ]
    * f4 -> TypeDefinitionBody()
    * </PRE>
    */
   public void visit(TypeDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> TypeDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; TypeDefinitionReference() )*
    * </PRE>
    */
   public void visit(ExtendedTypeDefinitions n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * </PRE>
    */
   public void visit(TypeDefinitionReference n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( TypeDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( TypeDefinitionElement() )*
    * </PRE>
    */
   public void visit(TypeDefinitionBody n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    * </PRE>
    */
   public void visit(TypeDefinitionElement n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> [ &lt;ABSTRACT&gt; ]
    * f2 -> &lt;PRIMITIVE&gt;
    * f3 -> FullyQualifiedName()
    * f4 -> [ FormalParameterDeclarationList() ]
    * f5 -> [ ExtendedPrimitiveDefinitions() ]
    * f6 -> PrimitiveDefinitionBody()
    * </PRE>
    */
   public void visit(PrimitiveDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ FormalParameterDeclaration() ( &lt;COMMA&gt; FormalParameterDeclaration() )* ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public void visit(FormalParameterDeclarationList n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public void visit(FormalParameterDeclaration n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> PrimitiveDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; PrimitiveDefinitionReference() )*
    * </PRE>
    */
   public void visit(ExtendedPrimitiveDefinitions n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * f1 -> [ ArgumentList() ]
    * </PRE>
    */
   public void visit(PrimitiveDefinitionReference n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ ArgumentAssignement() ( &lt;COMMA&gt; ArgumentAssignement() )* | Argument() ( &lt;COMMA&gt; Argument() )* ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public void visit(ArgumentList n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> Argument()
    * </PRE>
    */
   public void visit(ArgumentAssignement n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> AttributeValue()
    * </PRE>
    */
   public void visit(Argument n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( PrimitiveDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( PrimitiveDefinitionElement() )*
    * </PRE>
    */
   public void visit(PrimitiveDefinitionBody n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    *       | AttributeDefinition()
    *       | DataDefinition()
    *       | ImplementationDefinition()
    * </PRE>
    */
   public void visit(PrimitiveDefinitionElement n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;COMPOSITE&gt;
    * f2 -> FullyQualifiedName()
    * f3 -> [ FormalTypeParameterDeclarationList() ]
    * f4 -> [ FormalParameterDeclarationList() ]
    * f5 -> [ ExtendedCompositeDefinitions() ]
    * f6 -> CompositeDefinitionBody()
    * </PRE>
    */
   public void visit(CompositeDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LT&gt;
    * f1 -> FormalTypeParameterDeclaration()
    * f2 -> ( &lt;COMMA&gt; FormalTypeParameterDeclaration() )*
    * f3 -> &lt;GT&gt;
    * </PRE>
    */
   public void visit(FormalTypeParameterDeclarationList n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;CONFORMSTO&gt;
    * f2 -> TypeDefinitionReference()
    * </PRE>
    */
   public void visit(FormalTypeParameterDeclaration n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * f1 -> [ TypeArgumentList() ]
    * f2 -> [ ArgumentList() ]
    * </PRE>
    */
   public void visit(CompositeDefinitionReference n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LT&gt;
    * f1 -> [ TypeArgument() ( &lt;COMMA&gt; TypeArgument() )* | TypeArgumentAssignement() ( &lt;COMMA&gt; TypeArgumentAssignement() )* ]
    * f2 -> &lt;GT&gt;
    * </PRE>
    */
   public void visit(TypeArgumentList n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> TypeArgument()
    * </PRE>
    */
   public void visit(TypeArgumentAssignement n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> CompositeDefinitionReference()
    *       | &lt;ANY&gt;
    * </PRE>
    */
   public void visit(TypeArgument n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;EXTENDS&gt;
    * f1 -> CompositeDefinitionReference()
    * f2 -> ( &lt;COMMA&gt; CompositeDefinitionReference() )*
    * </PRE>
    */
   public void visit(ExtendedCompositeDefinitions n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt; ( CompositeDefinitionElement() )* &lt;RBRACE&gt;
    *       | ( CompositeDefinitionElement() )*
    * </PRE>
    */
   public void visit(CompositeDefinitionBody n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> InterfaceDefinition()
    *       | BindingDefinition()
    *       | SubComponentDefinition()
    * </PRE>
    */
   public void visit(CompositeDefinitionElement n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> ( FunctionalInterfaceDefinition() | FlowInterfaceDefinition() )
    * </PRE>
    */
   public void visit(InterfaceDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> ( &lt;PROVIDES&gt; | &lt;REQUIRES&gt; )
    * f1 -> [ &lt;OPTIONAL&gt; ]
    * f2 -> FullyQualifiedName()
    * f3 -> &lt;AS&gt;
    * f4 -> &lt;IDENTIFIER&gt;
    * f5 -> [ &lt;LBRACKET&gt; [ &lt;INTEGER_LITERAL&gt; ] &lt;RBRACKET&gt; ]
    * f6 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public void visit(FunctionalInterfaceDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> ( &lt;INPUT&gt; | &lt;OUTPUT&gt; )
    * f1 -> [ &lt;OPTIONAL&gt; ]
    * f2 -> FlowType()
    * f3 -> &lt;AS&gt;
    * f4 -> &lt;IDENTIFIER&gt;
    * f5 -> [ &lt;LBRACKET&gt; [ &lt;INTEGER_LITERAL&gt; ] &lt;RBRACKET&gt; ]
    * f6 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public void visit(FlowInterfaceDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> AttributeType()
    *       | IDTType()
    * </PRE>
    */
   public void visit(FlowType n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Path()
    * f1 -> &lt;DASH&gt;
    * f2 -> [ &lt;STRUCT&gt; | &lt;ENUM&gt; | &lt;UNION&gt; ]
    * f3 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public void visit(IDTType n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;ATTRIBUTE&gt;
    * f2 -> FlowType()
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> [ &lt;ASSIGN&gt; AttributeValue() ]
    * f5 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public void visit(AttributeDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;INT&gt;
    *       | &lt;STRING&gt;
    *       | &lt;INT8_T&gt;
    *       | &lt;UINT8_T&gt;
    *       | &lt;INT16_T&gt;
    *       | &lt;UINT16_T&gt;
    *       | &lt;INT32_T&gt;
    *       | &lt;UINT32_T&gt;
    *       | &lt;INT64_T&gt;
    *       | &lt;UINT64_T&gt;
    *       | &lt;INTPTR_T&gt;
    *       | &lt;UINTPTR_T&gt;
    * </PRE>
    */
   public void visit(AttributeType n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | ReferenceValue()
    *       | NullValue()
    *       | CompoundAttributeValue()
    * </PRE>
    */
   public void visit(AttributeValue n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> [ CompoundAttributeValueField() ( &lt;COMMA&gt; CompoundAttributeValueField() )* ]
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public void visit(CompoundAttributeValue n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> [ CompoundFieldName() ]
    * f1 -> AttributeValue()
    * </PRE>
    */
   public void visit(CompoundAttributeValueField n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;DOT&gt;
    * f1 -> &lt;IDENTIFIER&gt;
    * f2 -> &lt;ASSIGN&gt;
    * </PRE>
    */
   public void visit(CompoundFieldName n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;DATA&gt;
    * f2 -> ( DataField() | DataFile() )
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public void visit(DataDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Path()
    *       | &lt;INLINED_CODE&gt;
    * </PRE>
    */
   public void visit(DataFile n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> FlowType()
    * f1 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public void visit(DataField n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;SOURCE&gt;
    * f2 -> ( Path() | &lt;INLINED_CODE&gt; )
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public void visit(ImplementationDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;BINDS&gt;
    * f2 -> BindingComponentName()
    * f3 -> &lt;DOT&gt;
    * f4 -> &lt;IDENTIFIER&gt;
    * f5 -> [ &lt;LBRACKET&gt; &lt;INTEGER_LITERAL&gt; &lt;RBRACKET&gt; ]
    * f6 -> &lt;TO&gt;
    * f7 -> BindingComponentName()
    * f8 -> &lt;DOT&gt;
    * f9 -> &lt;IDENTIFIER&gt;
    * f10 -> [ &lt;LBRACKET&gt; &lt;INTEGER_LITERAL&gt; &lt;RBRACKET&gt; ]
    * f11 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public void visit(BindingDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
      n.f11.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    *       | &lt;THIS&gt;
    * </PRE>
    */
   public void visit(BindingComponentName n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;CONTAINS&gt;
    * f2 -> SimpleSubComponentReference()
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * </PRE>
    */
   public void visit(SubComponentDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> [ CompositeDefinitionReference() ]
    * f1 -> &lt;AS&gt;
    * f2 -> &lt;IDENTIFIER&gt;
    * f3 -> ( &lt;COMMA&gt; &lt;IDENTIFIER&gt; )*
    * f4 -> [ ( PrimitiveAnonymousDefinition() | CompositeAnonymousDefinition() ) ]
    * </PRE>
    */
   public void visit(SimpleSubComponentReference n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;PRIMITIVE&gt;
    * f2 -> &lt;LBRACE&gt;
    * f3 -> ( PrimitiveDefinitionElement() )*
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public void visit(PrimitiveAnonymousDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;COMPOSITE&gt;
    * f2 -> &lt;LBRACE&gt;
    * f3 -> ( CompositeDefinitionElement() )*
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public void visit(CompositeAnonymousDefinition n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;LBRACE&gt;
    * f2 -> ( PrimitiveDefinitionElement() )*
    * f3 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public void visit(PrimitiveAnonymousExtension n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;LBRACE&gt;
    * f2 -> ( CompositeDefinitionElement() )*
    * f3 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public void visit(CompositeAnonymousExtension n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> ( Annotation() )*
    * </PRE>
    */
   public void visit(Annotations n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;AT&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> [ AnnotationParameters() ]
    * </PRE>
    */
   public void visit(Annotation n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ AnnotationValuePairs() | AnnotationValue() ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public void visit(AnnotationParameters n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> AnnotationValuePair()
    * f1 -> ( &lt;COMMA&gt; AnnotationValuePair() )*
    * </PRE>
    */
   public void visit(AnnotationValuePairs n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> AnnotationValue()
    * </PRE>
    */
   public void visit(AnnotationValuePair n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | BooleanValue()
    *       | AnnotationAnnotationValue()
    *       | ArrayAnnotationValue()
    *       | NullValue()
    *       | PathValue()
    * </PRE>
    */
   public void visit(AnnotationValue n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Annotation()
    * </PRE>
    */
   public void visit(AnnotationAnnotationValue n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> [ AnnotationValue() ( &lt;COMMA&gt; AnnotationValue() )* ]
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public void visit(ArrayAnnotationValue n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;STRING_LITERAL&gt;
    * </PRE>
    */
   public void visit(StringValue n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> [ &lt;MINUS&gt; | &lt;PLUS&gt; ]
    * f1 -> &lt;INTEGER_LITERAL&gt;
    * </PRE>
    */
   public void visit(IntegerValue n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;BOOLEAN_LITERAL&gt;
    * </PRE>
    */
   public void visit(BooleanValue n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public void visit(ReferenceValue n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;NULL&gt;
    * </PRE>
    */
   public void visit(NullValue n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> Path()
    * </PRE>
    */
   public void visit(PathValue n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( &lt;DOT&gt; &lt;IDENTIFIER&gt; )*
    * </PRE>
    */
   public void visit(FullyQualifiedName n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * <PRE>
    * f0 -> [ &lt;SLASH&gt; ]
    * f1 -> [ &lt;DOT&gt; &lt;SLASH&gt; ]
    * f2 -> ( &lt;DOTDOT&gt; &lt;SLASH&gt; )*
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> ( &lt;SLASH&gt; &lt;IDENTIFIER&gt; )*
    * f5 -> [ &lt;DOT&gt; &lt;IDENTIFIER&gt; ]
    * </PRE>
    */
   public void visit(Path n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

}
